Revit 二次开发 获得元素相交的其他元素

    根据自己的需求来使用 第二种有时会出现过滤不出来  

第一种方法 

思路是根据这个元素得到一个包围这个元素的盒子  和要过滤的相交元素的类别 组合成一个 筛选器

 ///


        /// 获取相交元素 boundingBox
        ///

        /// 根据图元找相交
        /// 类别
        /// 是否包含自身
        /// 查找结果
        public static List GetIntersectElements(this Element element, BuiltInCategory category,bool contain=false)
        {
            List listElement = new List();
            Document doc = element.Document;
            BoundingBoxXYZ boundingBoxXyz = element.get_BoundingBox(doc.ActiveView);
            Outline outline = new Outline(boundingBoxXyz.Min, boundingBoxXyz.Max);
            BoundingBoxIntersectsFilter boundFilter = new BoundingBoxIntersectsFilter(outline);
            ElementCategoryFilter filter2 = new ElementCategoryFilter(category);
            LogicalAndFilter filter3 = new LogicalAndFilter(boundFilter, filter2);
            FilteredElementCollector collector = new FilteredElementCollector(doc);
            listElement = collector.WherePasses(filter3).WhereElementIsNotElementType().ToList();

            if (contain == false)
            {
               listElement.RemoveAll(m => m.Id == element.Id);
            }
           
            return listElement;
        }
        

 

第二种方法 

思路 先过滤类别 再根据api提供的相交的类进行过滤

        ///


        /// 获取相交图元
        ///

        /// 根据图元找相交
        /// 类别
        /// 是否包含自身
        /// 查找结果
        public static List GetIntersectElements(this Element element, BuiltInCategory category, bool contain = false)
        {
            var listResults = new FilteredElementCollector(element.Document).OfCategory(category).WherePasses(
                new ElementIntersectsElementFilter(element)).ToList();
                
            if (contain == false)
            {
                listResults.RemoveAll(p => p.Id == element.Id);
            }
            
            return listResults;
        }

你可能感兴趣的:(Revit,二次开发)